<?php
/*****
*	Book resource class
*****/
class BOOK
{
// Constructor
	function BOOK($db, $article = FALSE)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		$this->article = $article;
	}
// Display form fields for inputting book fields.
	function formFields($config)
	{
		$pString = '';
		if($this->article)
		{
			$key = 'book_title';
			$this->session->getVar($key) ?
				$sessVar = $this->session->getVar($key) : 
				$sessVar = '';
			$pString .= "<DIV CLASS=\"tr1\"><B>$config[$key]</B><BR>";
			$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
				"\" SIZE=\"25\" MAXLENGTH=\"255\">*</DIV>";
			$key = 'page_start';
			$this->session->getVar($key) ?
				$sessVar = $this->session->getVar($key) : 
				$sessVar = '';
			$pString .= "<DIV CLASS=\"tr2\"><B>$config[$key]</B><BR>";
			$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
				"\" SIZE=\"5\" MAXLENGTH=\"4\">*</DIV>";
			$key = 'page_end';
			$this->session->getVar($key) ?
				$sessVar = $this->session->getVar($key) : 
				$sessVar = '';
			$pString .= "<DIV CLASS=\"tr3\"><B>$config[$key]</B><BR>";
			$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
				"\" SIZE=\"5\" MAXLENGTH=\"4\"></DIV>";
			$pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
		}
		return $pString;
	}
// form fields for book series and reprint year
	function series()
	{
		include_once("classes/CONFIG.php");
		$config = new CONFIG();
		include_once("classes/HTML.php");
		$html = new HTML();
		$config->getFields('book');
		$key = 'series_title';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString = "<DIV CLASS=\"tr60\"><B>" . $config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"50\" MAXLENGTH=\"255\"></DIV>";
		$key = 'series_number';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '---';
		$newArray[0] = '---';
		for($i = 1; $i <= 20; $i++)
			$newArray[$i] = $i;
		$pString .= "<DIV CLASS=\"tr3\"><B>" . $config->fields[$key] . "</B><BR>";
		$this->session->getVar($key) ? 
			$pString .= $html->selectedBoxValue($key, $newArray, $sessVar, 5) : 
			$pString .= $html->selectFBoxValue($key, $newArray, 5);
		$pString .= "</DIV></DIV><DIV CLASS=\"clear\"><HR></DIV>";
		$pString .= "<DIV class=\"trFrame1\">";
		return $pString;
	}
// form fields for volumes
	function volumes()
	{
		include_once("classes/CONFIG.php");
		$config = new CONFIG();
		include_once("classes/HTML.php");
		$html = new HTML();
		$config->getFields('book');
		$key = 'volumes';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '---';
		$newArray[0] = '---';
		for($i = 2; $i <= 20; $i++)
			$newArray[$i] = $i;
		$pString = "<DIV CLASS=\"tr1\"><B>" . $config->fields[$key] . "</B><BR>";
		$this->session->getVar($key) ? 
			$pString .= $html->selectedBoxValue($key, $newArray, $sessVar, 5) : 
			$pString .= $html->selectFBoxValue($key, $newArray, 5);
		$pString .= "</DIV>";
		$key = 'volume_number';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '---';
		$newArray = array();
		$newArray[0] = '---';
		for($i = 1; $i <= 20; $i++)
			$newArray[$i] = $i;
		$pString .= "<DIV CLASS=\"tr2\"><B>" . $config->fields[$key] . "</B><BR>";
		$this->session->getVar($key) ? 
			$pString .= $html->selectedBoxValue($key, $newArray, $sessVar, 5) : 
			$pString .= $html->selectFBoxValue($key, $newArray, 5);
		$pString .= "</DIV>";
		$key = 'volume_year';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr3\"><B>" . $config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"5\" MAXLENGTH=\"4\"><BR>";
		$pString .= "<DIV class=\"hint\">(e.g. 1999)</DIV>";
		$pString .= "</DIV></DIV><DIV CLASS=\"clear\"><HR></DIV>";
		$pString .= "<DIV class=\"trFrame1\">";
		return $pString;
	}
// Write data to SQL tables
	function writeSql()
	{
		include_once("classes/AUTHOR.php");
		$author = new AUTHOR($this->db);
		include_once("classes/JOURNAL.php");
		$journal = new JOURNAL($this->db);
		include_once("classes/PUBLISHER.php");
		$publisher = new PUBLISHER($this->db);
		include_once("classes/EDITOR.php");
		$editor = new EDITOR($this->db);
		include_once("classes/NOTES.php");
		$notes = new NOTES($this->db);
		include_once("classes/KEYWORD.php");
		$keyword = new KEYWORD($this->db);
		include_once("classes/GROUP.php");
		$group = new GROUP($this->db);
		$keys = array();
		$values = array();
		$nulls = array();
// WRITER TABLE
		if(!$author->sqlArrays($keys, $values, $nulls, $this->session->getVar('type')))
				return FALSE;
// JOURNAL TABLE
		if(($this->session->getVar('type') == 'journal_article') || 
			($this->session->getVar('type') == 'web_article'))
		{
			if(!$journalID = $journal->writeSql())
				return FALSE;
			else if($journalID != 'NULL')
			{
				$keys[] = 'journal';
				$values[] = $journalID;
			}
		}
// PUBLISHER TABLE
		else
		{
			if(!$publisherID = $publisher->writeSql())
				return FALSE;
			else if($publisherID != 'NULL')
			{
				$keys[] = 'publisher';
				$values[] = $publisherID;
			}
		}
// RESOURCE TABLE
		$this->sqlArrays($keys, $values, $nulls);
// Type is guaranteed to be in the session and must be set in the database.  It is read here as updateSql() below
// does not require it (i.e. cannot update the type of resource).
		if($this->session->issetVar('type'))
		{
			$keys[] = 'type';
			$values[] = $this->db->tidyInput($this->session->getVar('type'));
		}
		$sqlKey = '';
		$sqlValue = "'";
		if(sizeof($keys))
		{
			$sqlKey =implode(", ", $keys);
			$sqlValue .= implode("', '", $values) . "'";
		}
		$sql = $this->db->insert('resource', $sqlKey, $sqlValue);
		if(!$this->db->query($sql))
			return FALSE;
		$id = $this->db->lastAutoID();
// KEYWORDS TABLE
		if(!$keyword->writeSql($id))
			return FALSE;
// GROUPS TABLE
		if(!$group->writeSql($id))
			return FALSE;
// BOOK_NOTES TABLE
		if(!$notes->writeSql($id))
			return FALSE;
// SUMMARY TABLE
		$this->summary();
		return TRUE;
	}
// build sql arrays for writing to xxxx_details table
	function sqlArrays(&$keys, &$values, &$nulls)
	{
		include_once("classes/HTML.php");
		$html = new HTML();
// Title is guaranteed to be in the session and must be set in the database
		if($this->session->issetVar('title'))
		{
			$keys[] = 'title';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('title')));
		}
		if($this->session->issetVar('subtitle'))
		{
			$keys[] = 'subtitle';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('subtitle')));
		}
		if($this->session->issetVar('year'))
		{
			$keys[] = 'year';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('year')));
		}
		else
			$nulls[] = "year=NULL";
		if($this->session->issetVar('edition'))
		{
			$keys[] = 'edition';
			$values[] =  $this->db->tidyInput($this->session->getVar('edition'));
		}
		else
			$nulls[] = "edition=NULL";
// if no author set, assume et_al should not be checked
		if($this->session->issetVar('et_al') && 
			($this->session->getVar('author1_surname') || $this->session->getVar('author1ID')))
		{
			$keys[] = 'et_al';
			$values[] = "Y";
		}
		else
			$nulls[] = "et_al=NULL";
// if no editor set, assume ed_et_al should not be checked
		if($this->session->issetVar('ed_et_al') && 
			($this->session->getVar('editor1_surname') || $this->session->getVar('editor1ID')))
		{
			$keys[] = 'ed_et_al';
			$values[] = "Y";
		}
		else
			$nulls[] = "ed_et_al=NULL";
// if no translator set, assume trans_et_al should not be checked
		if($this->session->issetVar('trans_et_al') && 
			($this->session->getVar('translator1_surname') || $this->session->getVar('translator1ID')))
		{
			$keys[] = 'trans_et_al';
			$values[] = "Y";
		}
		else
			$nulls[] = "trans_et_al=NULL";
// if no reviser set, assume rev_et_al should not be checked
		if($this->session->issetVar('rev_et_al') && 
			($this->session->getVar('reviser1_surname') || $this->session->getVar('reviser1ID')))
		{
			$keys[] = 'rev_et_al';
			$values[] = "Y";
		}
		else
			$nulls[] = "rev_et_al=NULL";
		if($this->session->issetVar('series_title'))
		{
			$keys[] = 'series_title';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('series_title')));
		}
		else
			$nulls[] = "series_title=NULL";
		if($this->session->issetVar('series_number'))
		{
			$keys[] = 'series_number';
			$values[] = $this->db->tidyInput($this->session->getVar('series_number'));
		}
		else
			$nulls[] = "series_number=NULL";
		if($this->session->issetVar('reprint_year'))
		{
			$keys[] = 'reprint_year';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('reprint_year')));
		}
		else
			$nulls[] = "reprint_year=NULL";
		if($this->session->issetVar('volumes'))
		{
			$keys[] = 'volumes';
			$values[] = $this->db->tidyInput($this->session->getVar('volumes'));
		}
		else
			$nulls[] = "volumes=NULL";
		if($this->session->issetVar('volume_number'))
		{
			$keys[] = 'volume_number';
			$values[] = $this->db->tidyInput($this->session->getVar('volume_number'));
		}
		else
			$nulls[] = "volume_number=NULL";
		if($this->session->issetVar('volume_year'))
		{
			$keys[] = 'volume_year';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('volume_year')));
		}
		else
			$nulls[] = "volume_year=NULL";
		if($this->session->issetVar('book_title'))
		{
			$keys[] = 'book_title';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('book_title')));
		}
		else
			$nulls[] = "book_title=NULL";
		if($this->session->issetVar('page_start'))
		{
			$keys[] = 'page_start';
			$values[] =  $this->db->tidyInput($html->removeNl($this->session->getVar('page_start')));
		}
		else
			$nulls[] = "page_start=NULL";
		if($this->session->issetVar('page_end'))
		{
			$keys[] = 'page_end';
			$values[] =  $this->db->tidyInput($html->removeNl($this->session->getVar('page_end')));
		}
		else
			$nulls[] = "page_end=NULL";
		if($this->session->issetVar('journal_volume'))
		{
			$keys[] = 'journal_volume';
			$values[] =  $this->db->tidyInput($this->session->getVar('journal_volume'));
		}
		else
			$nulls[] = "journal_volume=NULL";
		if($this->session->issetVar('journal_number'))
		{
			$keys[] = 'journal_number';
			$values[] =  $this->db->tidyInput($this->session->getVar('journal_number'));
		}
		else
			$nulls[] = "journal_number=NULL";
		if($this->session->issetVar('web_address'))
		{
			$keys[] = 'web_address';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('web_address')));
		}
		else
			$nulls[] = "web_address=NULL";
		if($this->session->issetVar('date_accessed'))
		{
			$keys[] = 'date_accessed';
			$values[] = $this->db->tidyInput($html->removeNl($this->session->getVar('date_accessed')));
		}
		else
			$nulls[] = "date_accessed=NULL";
	}
// Update SQL for resource (after EDIT)
	function updateSql($resourceID, $type)
	{
		include_once("classes/AUTHOR.php");
		$author = new AUTHOR($this->db);
		include_once("classes/JOURNAL.php");
		$journal = new JOURNAL($this->db);
		include_once("classes/PUBLISHER.php");
		$publisher = new PUBLISHER($this->db);
		include_once("classes/KEYWORD.php");
		$keyword = new KEYWORD($this->db);
		include_once("classes/NOTES.php");
		$notes = new NOTES($this->db);
		include_once("classes/GROUP.php");
		$group = new GROUP($this->db);
		include_once("classes/EDITOR.php");
		$editor = new EDITOR($this->db);
		include_once("classes/CONFIG.php");
		$config = new CONFIG();
		$config->writers();
// Grab old author, editor, etc. IDs
		$old = array();
		$author->existing($resourceID, $config->writersArray, $old);
		$oldJournalId = '';
		$oldPublisherId = '';
		$keys = array();
		$values = array();
		$nulls = array();
// old journal ID and new ID
		if(($this->session->getVar('type') == 'journal_article') || 
			($this->session->getVar('type') == 'web_article'))
		{
			$sql = $this->db->select('resource', 'journal', "WHERE id=$resourceID");
			$sth = $this->db->query($sql);
			$oldJournalId = $this->db->fetchOne($sth);
			if(!$journalID = $journal->writeSql())
				return FALSE;
			if($journalID != 'NULL')
			{
				$keys[] = 'journal';
				$values[] = $journalID;
			}
			else
			{
				$nulls[] = "journal=NULL";
			}
		}
// old publisher ID and new ID
		else
		{
			$sql = $this->db->select('resource', 'publisher', "WHERE id=$resourceID");
			$sth = $this->db->query($sql);
			$oldPublisherId = $this->db->fetchOne($sth);
			if(!$publisherID = $publisher->writeSql())
				return FALSE;
			if($publisherID != 'NULL')
			{
				$keys[] = 'publisher';
				$values[] = $publisherID;
			}
			else
			{
				$nulls[] = "publisher=NULL";
			}
		}
// Update WRITER TABLE
//  We don't use an update here - if author/editor etc doesn't exist, it is inserted into writer table.  
// If it does, simply return the authorID to be updated in the resource table.
		if(!$author->sqlArrays($keys, $values, $nulls, $type))
				return FALSE;
// RESOURCE TABLE
		$this->sqlArrays($keys, $values, $nulls);
		if(sizeof($keys))
		{
			foreach($keys as $key)
				$array[] = "$key=" . "'" . $this->db->tidyInput(array_shift($values)) . "'";
			$string = implode(', ', $array);
			if(sizeof($nulls))
				$string .= ', ' . implode(', ', $nulls);
			$conditions = "WHERE id=$resourceID";
			$sql = $this->db->update('resource', $string, $conditions);
			if(!$this->db->query($sql))
				return FALSE;
		}
// KEYWORDS TABLE
		if(!$keyword->writeSql($resourceID, TRUE))
			return FALSE;
// GROUPS TABLE
		if(!$group->writeSql($resourceID, TRUE))
			return FALSE;
// BOOK_NOTES TABLE
		if(!$notes->updateSql($resourceID))
			return FALSE;
// remove excess authors, editors?
		if(sizeof($old))
			$author->checkDelete($old);
// remove excess publisher?
		if($oldPublisherId)
			$publisher->checkDelete($oldPublisherId);
// remove excess journal?
		if($oldJournalId)
			$journal->checkDelete($oldJournalId);
		return TRUE;
	}
// update total_resources in summary table
	function summary()
	{
		$sql = $this->db->update('summary', "total_resources = total_resources + 1");
		$this->db->query($sql);
	}
}
?>
