<?php
/*****
* HELP class
*****/
class HELP
{
// Constructor
	function HELP()
	{
// These are closed in the calling function (DISPLAY::footer())
		$this->pString = "<DIV class=\"mainFrame\">";
		$this->pString .= "<DIV class=\"main\">";
	}
// Help page
	function main()
	{
		$this->pString .= $this->internalAnchors();
		$this->pString .= $this->accessibilityHelp();
		$this->pString .= "<P><HR><DIV class=\"back\"><A HREF=\"#top\">Top</A></DIV>";
		$this->pString .= "<DIV class=\"clear\"></DIV>";
		$this->pString .= $this->textInputHelp();
		$this->pString .= "<P><HR><DIV class=\"back\"><A HREF=\"#top\">Top</A></DIV>";
		$this->pString .= "<DIV class=\"clear\"></DIV>";
		$this->pString .= $this->resourceHelp();
		$this->pString .= "<P><HR><DIV class=\"back\"><A HREF=\"#top\">Top</A></DIV>";
		$this->pString .= "<DIV class=\"clear\"></DIV>";
		return $this->pString;
	}
// print help on accessibility and fonts
	function accessibilityHelp()
	{
		$this->pString .= "<A NAME=\"accessibility\"><B>Accessibility/Fonts:</B><BR></A>";
		$this->pString .= "WIKINDX uses Cascading Style Sheets to allow WIKINDX administrators (or 
			single users) the freedom to design their own layout.  The default wikindx.css uses 
			'<B>em</B>' for font size and margins in preference to pixels.  Whereas pixels are an 
			absolute (more or less) font size, em is relative and, among a few other things, depends 
			on the font size settings as set in the preferences of your web browser.<P>";
		$this->pString .= "This provides partially-sighted persons the option to increase font sizes 
			yet still retain the size-relationship between fonts as set in wikindx.css.  If you find 
			that large font sizes make the layout seem weird, you can do one of two things (besides 
			living with it).  You can decrease the font size in your web browser preferences until 
			the layout reverts or you can edit the layout of WIKINDX yourself by editing wikindx.css or 
			by creating a new CSS file and editing config.inc accordingly.  Naturally, the latter can 
			only be performed by single users or WIKINDX administrators.";
	}
// print help on resources
	function resourceHelp()
	{
		$this->pString .= "<A NAME=\"resources\"><B>Resources:</B><BR></A>";
		$this->pString .= "A resource is body of work which can be referenced.  It may be a complete book, an 
			article in a book or a journal article etc. and is therefore analagous to a single entry 
			in a bibliography.<P>";
		$this->pString .= "A resource, in addition to its authorship, publication etc. details, may have 
			one general note, and any number of quotes and musings attached to it. The general note 
			differs from a musing in that the former, of which there may be only one, is intended to 
			be a broad description or opinion about the whole resource while the latter, of which there may 
			be many, is intended for various specific thoughts about the resource.<P>";
		$this->pString .= "When listing all resources. the letters 'V', 'n', 'q', 'm' and 'E' may be displayed 
			to the right of each resource:";
		$this->pString .= "<DIV class=\"list\"><UL>";
		$this->pString .= "<LI><B>V</B> Click to view all details about the resource.";
		$this->pString .= "<LI><B>n</B> Click to view/add/edit the general note about the resource.";
		$this->pString .= "<LI><B>q</B> Click to view/add/edit a quote from the resource.";
		$this->pString .= "<LI><B>m</B> Click to view/add/edit a thought (a musing) about the resource.";
		$this->pString .= "<LI><B>E</B> Click to edit the details of the resource.";
		$this->pString .= "</UL></DIV>";
		$this->pString .= "Any of 'n', 'q' and 'm' displayed in uppercase indicates at 
			least one item exists. If you do not see a letter, you do not have write/edit permissions 
			AND there are no items of that type for that resource for you to view.";
	}
// print help on text input
	function textInputHelp()
	{
		$this->pString .= "<A NAME=\"textInput\"><B>Text Input:</B><BR></A>";
		$this->pString .= "HTML code will be stripped from all input.<P>";
		$this->pString .= "If you wish to write a hyperlink in a note, quote or musing, 
			use [url=address]title[/url]. e.g.:";
		$this->pString .= "<DIV class=\"code\">
			[url=http://www.waikato.ac.nz]University of Waikato[/url]</CODE></DIV>";
		$this->pString .= "<P>This will show as: <A HREF=\"http://www.waikato.ac.nz\" TARGET=\"_blank\">
			University of Waikato</A>";
		$this->pString .= "<BR>Don't forget the 'http://'";
	}
// print internal anchors
	function internalanchors()
	{
		$this->pString .= "<A NAME=\"top\"></A>";
		$this->pString .= "<A HREF=\"#accessibility\">Accessibility/Fonts</A><BR>";
		$this->pString .= "<A HREF=\"#textInput\">Text Input</A><BR>";
		$this->pString .= "<A HREF=\"#resources\">Resources</A><BR>";
		$this->pString .= "<P><HR><P>";
	}
}
