<?php
/*****
*	Name class
*****/
class NAME
{
// Constructor
	function NAME($db, $type)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		include_once("classes/CONFIG.php");
		$this->config = new CONFIG();
		$this->config->getFields($type);
	}
// print out fields for writer's firstname
	function firstname($writer, $required = '')
	{
		$key = $writer . '_firstname';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString = "<DIV CLASS=\"tr1\"><B>" . $this->config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"20\" MAXLENGTH=\"255\">$required</DIV>";
		return $pString;
	}
// print out fields for writer's initials
	function initials($writer, $required = '')
	{
		$key = $writer . '_initials';
// initials stored in database as up to 5 space-delimited characters.  Must remove spaces
		$this->session->getVar($key) ?
			$sessVar = implode('', explode(' ', $this->session->getVar($key))) : 
			$sessVar = '';
		$pString = "<DIV CLASS=\"tr2\"><B>" . $this->config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"6\" MAXLENGTH=\"5\">$required</DIV>";
		return $pString;
	}
// print out fields for writer's surname
	function surname($writer, $required = '')
	{
		$key = $writer . '_surname';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString = "<DIV CLASS=\"tr3\"><B>" . $this->config->fields[$key] . "</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"20\" MAXLENGTH=\"255\">$required</DIV>";
		return $pString;
	}
// print out checkbox for writer's et al field
	function etAl($etAl)
	{
		$this->session->getVar($etAl) ?
			$sessVar = $this->session->getVar($etAl) : 
			FALSE;
		$pString = "<DIV CLASS=\"tr1\"><B><BR>" . $this->config->fields[$etAl] . "</B> ";
		isset($sessVar) ? 
			$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"$etAl\" CHECKED></DIV>" : 
			$pString .= "<INPUT TYPE=\"checkbox\" NAME=\"$etAl\"></DIV>";
		return $pString;
	}
// Display explanation and existing writers in select box first.
	function preExistFormFields($writer, $writersArray)
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		$id = $writer . 'ID';
// Add 'None' to select box list
		$newArray = array();
		$newArray[0] = 'None';
		foreach($writersArray as $key => $value)
			$newArray[$key] = $value;
// create label array
		$labelArray = array(
				'author1'	=>	"<B>First author: </B><DIV CLASS=\"hint\">
								You may select a pre-existing author or enter a 
								new one. A new entry will supersede the selection 
								of a pre-existing author.</DIV>",
				'author2'	=>	"<B>Second author: </B>",
				'author3'	=>	"<B>Third author: </B>",
				'author4'	=>	"<B>Fourth author: </B>",
				'author5'	=>	"<B>Fifth author: </B>",
				'author6'	=>	"<B>Sixth author: </B>",
				'editor1'	=>	"<B>First Editor: </B><DIV CLASS=\"hint\">
								You may select a pre-existing editor or enter a 
								new one. A new entry will supersede the selection 
								of a pre-existing editor.</DIV>",
				'editor2'	=>	"<B>Second Editor: </B>",
				'editor3'	=>	"<B>Third Editor: </B>",
				'editor4'	=>	"<B>Fourth Editor: </B>",
				'editor5'	=>	"<B>Fifth Editor: </B>",
				'editor6'	=>	"<B>Sixth Editor: </B>",
				'translator1'	=>	"<B>First Translator: </B><DIV CLASS=\"hint\">
								You may select a pre-existing translator or enter a 
								new one. A new entry will supersede the selection 
								of a pre-existing translator.</DIV>",
				'translator2'	=>	"<B>Second Translator: </B>",
				'translator3'	=>	"<B>Third Translator: </B>",
				'reviser1'	=>	"<B>First Reviser: </B><DIV CLASS=\"hint\">
								You may select a pre-existing reviser or enter a 
								new one. A new entry will supersede the selection 
								of a pre-existing reviser.</DIV>",
				'reviser2'	=>	"<B>Second Reviser: </B>",
				'reviser3'	=>	"<B>Third Reviser: </B>",
			);
// create classArray
		$classArray = array(
				'author1'	=>	'trFrame1',
				'author2'	=>	'trFrame2',
				'author3'	=>	'trFrame1',
				'author4'	=>	'trFrame2',
				'author5'	=>	'trFrame1',
				'author6'	=>	'trFrame2',
				'editor1'	=>	'trFrame1',
				'editor2'	=>	'trFrame2',
				'editor3'	=>	'trFrame1',
				'editor4'	=>	'trFrame2',
				'editor5'	=>	'trFrame1',
				'editor6'	=>	'trFrame2',
				'translator1'	=>	'trFrame1',
				'translator2'	=>	'trFrame2',
				'translator3'	=>	'trFrame1',
				'reviser1'	=>	'trFrame1',
				'reviser2'	=>	'trFrame2',
				'reviser3'	=>	'trFrame1',
			);
		$pString = "<DIV CLASS=\"tr60\">";
		$pString .= $labelArray[$writer];
		$pString .= "</DIV><DIV CLASS=\"tr3\">";
		$this->session->issetVar($id) ? 
			$pString .= $html->selectedBoxValue($id, $newArray, $this->session->getVar($id), 5) : 
			$pString .= $html->selectFBoxValue($id, $newArray, 5);
		$pString .= "</DIV></DIV><DIV CLASS=\"clear\"></DIV><DIV CLASS=\"" . $classArray[$writer] . "\">";
		return $pString;
	}
// grab all writer's IDs and names
	function grabAll()
	{
		$sql = $this->db->select('writer', '*', "ORDER BY surname");
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
		{
			$string = $row['surname'] . ', ' . $row['firstname'];
			if($row['initials'])
				$string .= ' ' . $row['initials'];
			$writers[$row['id']] = $string;
		}
		if($this->db->numRows($sth))
			return $writers;
		else
			return FALSE;
	}
}
?>
