<?php
/*****
*	Order resources class
*****/
class ORDER
{
// Constructor
	function ORDER($db, $auth, $vars)
	{
		$this->db = $db;
		$this->auth = $auth;
		$this->vars = $vars;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		include_once("classes/CONFIG.php");
		$this->config = new CONFIG();
	}
// Display forms for ordering
	function init()
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		global $PHP_SELF;
		$pString = '';
		$this->config->order();
		$this->orderArray = $this->config->orderArray;
		$this->groups = array();
		$this->keywords = array();
		$this->writers = array();
		$this->publishers = array();
		$this->journals = array();
		$this->getKeywords();
		$this->getGroups();
		$this->getWriters();
		$this->getPublishers();
		$this->getJournals();
		if(sizeof($this->orderArray))
		{
			$pString .= "<DIV CLASS=\"searchtext\">";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"processOrder\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"orderMethod\" VALUE=\"orderAll\">";
			$pString .= "List all by:<BR>";
			if(!$this->session->getVar('orderAll'))
				$pString .= $html->selectFBoxValue('orderAll', $this->orderArray, $size = 5);
			else if($this->session->getVar('orderAll'))
				$pString .= $html->selectedBoxValue('orderAll', $this->orderArray, 
					$this->session->getVar('orderAll'), $size = 5);
			$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"list\"></DIV></FORM>";
			$pString .= "</DIV>";
		}
		else
		{
			$pString .= "No groups or keywords have been set up yet.";
		}
		if(array_key_exists('group', $this->orderArray))
		{
			$pString .= "<DIV CLASS=\"searchtext\">";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"processOrder\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"orderMethod\" VALUE=\"orderGroup\">";
			$pString .= "Group:<BR>";
			if(!$this->session->getVar('orderGroup'))
				$pString .= $html->selectFBoxValueMultiple('orderGroup[]', $this->groups, $size = 5);
			else if($this->session->getVar('orderGroup'))
			{
				$groups = explode(',', $this->session->getVar('orderGroup'));
				$pString .= $html->selectedBoxValueMultiple('orderGroup[]', $this->groups, 
					$groups, $size = 5);
			}
			$pString .= "<DIV CLASS=\"hint\">(Multiples can be chosen.)</DIV>";
			$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"list\"></DIV></FORM>";
			$pString .= "</DIV>";
		}
		if(array_key_exists('keyword', $this->orderArray))
		{
			$pString .= "<DIV CLASS=\"searchtext\">";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"processOrder\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"orderMethod\" VALUE=\"orderKeyword\">";
			$pString .= "Keyword:<BR>";
			if(!$this->session->getVar('orderKeyword'))
				$pString .= $html->selectFBoxValueMultiple('orderKeyword[]', $this->keywords, $size = 5);
			else if($this->session->getVar('orderKeyword'))
			{
				$keywords = explode(',', $this->session->getVar('orderKeyword'));
				$pString .= $html->selectedBoxValueMultiple('orderKeyword[]', $this->keywords, 
					$keywords, $size = 5);
			}
			$pString .= "<DIV CLASS=\"hint\">(Multiples can be chosen.)</DIV>";
			$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"list\"></DIV></FORM>";
			$pString .= "</DIV>";
		}
		$pString .= "<DIV CLASS=\"clear\"><HR></DIV>";
		if(sizeof($this->writers))
		{
			$pString .= "<DIV CLASS=\"searchtext\">";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"processOrder\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"orderMethod\" VALUE=\"orderWriter\">";
			$pString .= "Writer:<BR>";
			if(!$this->session->getVar('orderWriter'))
				$pString .= $html->selectFBoxValue('orderWriter', $this->writers, $size = 5);
			else if($this->session->getVar('orderWriter'))
			{
				$groups = explode(',', $this->session->getVar('orderWriter'));
				$pString .= $html->selectedBoxValue('orderWriter', $this->writers, 
					$this->session->getVar('orderWriter'), $size = 5);
			}
			$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"list\"></DIV></FORM>";
			$pString .= "</DIV>";
		}
		if(sizeof($this->publishers))
		{
			$pString .= "<DIV CLASS=\"searchtext\">";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"processOrder\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"orderMethod\" VALUE=\"orderPublisher\">";
			$pString .= "Publisher:<BR>";
			if(!$this->session->getVar('orderPublisher'))
				$pString .= $html->selectFBoxValue('orderPublisher', $this->publishers, $size = 5);
			else if($this->session->getVar('orderPublisher'))
			{
				$groups = explode(',', $this->session->getVar('orderPublisher'));
				$pString .= $html->selectedBoxValue('orderPublisher', $this->publishers, 
					$this->session->getVar('orderPublisher'), $size = 5);
			}
			$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"list\"></DIV></FORM>";
			$pString .= "</DIV>";
		}
		if(sizeof($this->journals))
		{
			$pString .= "<DIV CLASS=\"searchtext\">";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"processOrder\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"orderMethod\" VALUE=\"orderJournal\">";
			$pString .= "Journal:<BR>";
			if(!$this->session->getVar('orderJournal'))
				$pString .= $html->selectFBoxValue('orderJournal', $this->journals, $size = 5);
			else if($this->session->getVar('orderJournal'))
			{
				$groups = explode(',', $this->session->getVar('orderJournal'));
				$pString .= $html->selectedBoxValue('orderJournal', $this->journals, 
					$this->session->getVar('orderJournal'), $size = 5);
			}
			$pString .= "<DIV ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"list\"></DIV></FORM>";
			$pString .= "</DIV>";
		}
		$pString .= "<DIV CLASS=\"clear\"></DIV>";
		return $pString;
	}
// get keywords - remove from orderArray if none
	function getKeywords()
	{
		include_once("classes/KEYWORD.php");
		$keyword = new KEYWORD($this->db);
		$sth = $keyword->grabAll();
		if($this->db->numRows($sth))
		{
			while($row = $this->db->fetchAssoc($sth))
				$this->keywords[$row['id']] = $row['keyword'];
			return;
		}
		unset($this->orderArray['keywords']);
	}
// get groups - remove from orderArray if none
	function getGroups()
	{
		global $WIKINDX_GROUPS;
		if(sizeof($WIKINDX_GROUPS) > 1)
		{
			$this->groups = $WIKINDX_GROUPS;
			natcasesort($this->groups);
			return;
		}
		unset($this->orderArray['groups']);
	}
// get writers
	function getWriters()
	{
		$sql = $this->db->select('writer', '*', "ORDER BY surname");
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
		{
			$string = $row['surname'] . ', ' . $row['firstname'];
			if($row['initials'])
				$string .= ' ' . $row['initials'];
			$this->writers[$row['id']] = $string;
		}
	}
// get publishers
	function getPublishers()
	{
		$sql = $this->db->select('publisher', '*', "ORDER BY name");
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
		{
			$string = $row['name'] . ': ' . $row['location'];
			$this->publishers[$row['id']] = $string;
		}
	}
// get journals
	function getJournals()
	{
		$sql = $this->db->select('journal', '*', "ORDER BY journal_title");
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
			$this->journals[$row['id']] = $row['journal_title'];
	}
// process the ordering
	function processOrder()
	{
		include_once("classes/MANIFEST.php");
		$manifest = new MANIFEST(FALSE, $this->db, $this->auth, $this->vars);
		$this->writeSession();
		$manifest->order($this);
		$this->config->commonSql('all');
		$pString = $this->parse();
		return $pString;
	}
// parse input by orderMethod and order
	function parse()
	{
		if($this->vars['orderMethod'] == 'orderAll')
		{
			if($this->vars['orderAll'] == 'author')
				return $this->orderAuthor();
			if($this->vars['orderAll'] == 'type')
				return $this->orderType();
			else if($this->vars['orderAll'] == 'title')
				return $this->orderTitle();
			else if($this->vars['orderAll'] == 'publisher')
				return $this->orderPublisher();
			else if($this->vars['orderAll'] == 'year')
				return $this->orderYear();
			else if($this->vars['orderAll'] == 'group')
				return $this->orderGroup();
			else if($this->vars['orderAll'] == 'keyword')
				return $this->orderKeyword();
		}
		else if($this->vars['orderMethod'] == 'orderGroup')
		{
			return $this->orderGroup($this->vars['orderGroup']);
		}
		else if($this->vars['orderMethod'] == 'orderKeyword')
		{
			return $this->orderKeyword($this->vars['orderKeyword']);
		}
		else if($this->vars['orderMethod'] == 'orderWriter')
		{
			return $this->orderWriter($this->vars['orderWriter']);
		}
		else if($this->vars['orderMethod'] == 'orderPublisher')
		{
			return $this->orderOnePublisher($this->vars['orderPublisher']);
		}
		else if($this->vars['orderMethod'] == 'orderJournal')
		{
			return $this->orderJournal($this->vars['orderJournal']);
		}
	}
// query database and display results
	function displayOrder($sql, $title, $key = FALSE)
	{
		$pString = '';
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
		{
			$pString .= "No resources found for this selection.";
			return $pString;
		}
		$pString .= $title;
		$index = 0;
		while($row = $this->db->fetchAssoc($sth))
		{
			!$key ? $key = $row['type'] : $key;
			$pString .= DISPLAY::displayResource($row, $index, $key);
			$index++;
		}
		return $pString;
	}
// order by resource first author (or, if no first author, first editor)
	function orderAuthor()
	{
		include_once("classes/DISPLAY.php");
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id";
		$condition = $this->config->condition;
		$conditionString = $condition . " ORDER BY author1_surname";
		$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
		return $this->displayOrder($sql, "AUTHOR:");
	}
// list resources by resource type
	function ordertype()
	{
		include_once("classes/DISPLAY.php");
		$pString = '';
		$this->config->resourceTypes();
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id";
		foreach($this->config->types as $key => $label)
		{
			$condition = $this->config->condition . " WHERE resource.type='$key' ORDER BY author1_surname";
			$sql = $this->db->select('resource', $this->config->stmt, $condition);
			$pString .= $this->displayOrder($sql, "TYPE:&nbsp;$label", $key);
			$pString .= "<P><HR><P>";
		}
		return $pString;
	}
// order by resource publisher
	function orderPublisher()
	{
		include_once("classes/DISPLAY.php");
		$this->config->stmt .= ", num_quotes, num_musings, notes, publisher.name";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id";
		$condition = $this->config->condition;
		$conditionString = $condition . " ORDER BY publisher_name, author1_surname";
		$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
		return $this->displayOrder($sql, "PUBLISHER:");
	}
// order by resource title
	function orderTitle()
	{
		include_once("classes/DISPLAY.php");
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id";
		$condition = $this->config->condition;
		$conditionString = $condition . " ORDER BY title";
		$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
		return $this->displayOrder($sql, "TITLE:");
	}
// order by year of publication
	function orderYear()
	{
		include_once("classes/DISPLAY.php");
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id";
		$condition = $this->config->condition;
		$conditionString = $condition . " ORDER BY year DESC, author1_surname";
		$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
		return $this->displayOrder($sql, "YEAR of PUBLICATION:");
	}
// order by group
	function orderGroup($sessGroup = FALSE)
	{
		include_once("classes/DISPLAY.php");
		global $WIKINDX_GROUPS;
		$groups = $WIKINDX_GROUPS;
		natcasesort($groups);
		$pString = '';
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id 
				LEFT JOIN resource_groups AS rg ON resource.id=rg.id";
		if($sessGroup)
		{
			foreach($sessGroup as $group)
			{
				$setConditionArray[] = "FIND_IN_SET($group, rg.groups)";
				$titleArray[] = $groups[$group];
			}
			$condition = $this->config->condition;
			$conditionString = $condition . " WHERE " . implode(' AND ', $setConditionArray) . 
				" ORDER BY author1_surname";
			$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
			$pString .= $this->displayOrder($sql, "GROUP:&nbsp;" . implode(', ', $titleArray));
		}
// else all groups
		else
		{
			foreach($groups as $key => $group)
			{
				$condition = $this->config->condition;
				$conditionString = $condition . " WHERE FIND_IN_SET($key, rg.groups)" . 
					" ORDER BY author1_surname";
				$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
				$pString .= $this->displayOrder($sql, "GROUP:&nbsp;" . $group);
				$pString .= "<P><HR><P>";
			}
		}
		return $pString;
	}
// order by keyword
	function orderKeyword($sessKeyword = FALSE)
	{
		include_once("classes/DISPLAY.php");
		include_once("classes/KEYWORD.php");
		$sth = KEYWORD::grabAll();
		while($row = $this->db->fetchAssoc($sth))
			$keywordList[$row['id']] = $row['keyword'];
		$pString = '';
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id 
				LEFT JOIN resource_keywords AS rk ON resource.id=rk.id";
		if($sessKeyword)
		{
			foreach($sessKeyword as $keyword)
			{
				$setConditionArray[] = "FIND_IN_SET($keyword, rk.keywords)";
				$titleArray[] = $keywordList[$keyword];
			}
			$condition = $this->config->condition;
			$conditionString = $condition . " WHERE " . implode(' AND ', $setConditionArray) . 
				" ORDER BY author1_surname";
			$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
			$pString .= $this->displayOrder($sql, "KEYWORD:&nbsp;" . implode(', ', $titleArray));
		}
// else all keywords
		else
		{
			foreach($keywordList as $id => $keyword)
			{
				$condition = $this->config->condition;
				$conditionString = $condition . " WHERE FIND_IN_SET($id, rk.keywords)" . 
					" ORDER BY author1_surname";
				$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
				$pString .= $this->displayOrder($sql, "KEYWORD:&nbsp;" . $keyword);
				$pString .= "<P><HR><P>";
			}
		}
		return $pString;
	}
// order by one writer (author, editor, translator, reviser)
	function orderWriter()
	{
		include_once("classes/DISPLAY.php");
		$pString = '';
		$writer = $this->vars['orderWriter'];
		$this->config->stmt .= ", num_quotes, num_musings, notes";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id";
		$condition = $this->config->condition;
		$conditionString = $condition . " WHERE resource.author1=$writer 
			OR resource.author2=$writer 
			OR resource.author3=$writer 
			OR resource.editor1=$writer 
			OR resource.editor2=$writer 
			OR resource.editor3=$writer 
			OR resource.translator1=$writer 
			OR resource.translator2=$writer 
			OR resource.translator3=$writer 
			OR resource.reviser1=$writer 
			OR resource.reviser2=$writer 
			OR resource.reviser3=$writer 
			ORDER BY author1_surname";
		$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
		{
			$pString .= "No resources found for this selection.";
			return $pString;
		}
// Grab this writer's name
		$wSql = $this->db->select('writer', 'firstname, surname, initials', "WHERE id=$writer");
		$nameSth = $this->db->query($wSql);
		$name = $this->db->fetchAssoc($nameSth);
		$writerName = $name['firstname'];
		if($name['initials'])
			$writerName .= ' ' . $name['initials'];
		$writerName .= ' ' . $name['surname'];
		$pString .= "WRITER:&nbsp;" . $writerName;
		$index = 0;
		while($row = $this->db->fetchAssoc($sth))
		{
			$pString .= DISPLAY::displayResource($row, $index, $row['type']);
			$index++;
		}
		return $pString;
	}
// order by one publisher
	function orderOnePublisher()
	{
		include_once("classes/DISPLAY.php");
		$pString = '';
		$publisher = $this->vars['orderPublisher'];
		$this->config->stmt .= ", num_quotes, num_musings, notes, 
			CONCAT_WS(': ', publisher.name, publisher.location) AS publisher_name";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id";
		$condition = $this->config->condition;
		$conditionString = $condition . " WHERE resource.publisher=$publisher ORDER BY author1_surname";
		$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
		{
			$pString .= "No resources found for this selection.";
			return $pString;
		}
		$index = 0;
		while($row = $this->db->fetchAssoc($sth))
		{
			if(!$index)
			{
				$pString .= "PUBLISHER:&nbsp;" . $row['publisher_name'];
			}
			$pString .= DISPLAY::displayResource($row, $index, $row['type']);
			$index++;
		}
		return $pString;
	}
// order by one journal
	function orderJournal()
	{
		include_once("classes/DISPLAY.php");
		$pString = '';
		$journal = $this->vars['orderJournal'];
		$this->config->stmt .= ", num_quotes, num_musings, notes, journal_title";
		$this->config->condition .= " LEFT JOIN resource_notes ON resource.id=resource_notes.id";
		$condition = $this->config->condition;
		$conditionString = $condition . " WHERE resource.journal=$journal ORDER BY author1_surname";
		$sql = $this->db->select('resource', $this->config->stmt, $conditionString);
		$sth = $this->db->query($sql);
		if(!$this->db->numRows($sth))
		{
			$pString .= "No resources found for this selection.";
			return $pString;
		}
		$index = 0;
		while($row = $this->db->fetchAssoc($sth))
		{
			if(!$index)
			{
				$pString .= "JOURNAL:&nbsp;" . $row['journal_title'];
			}
			$pString .= DISPLAY::displayResource($row, $index, $row['type']);
			$index++;
		}
		return $pString;
	}
// write the session data
	function writeSession()
	{
		$array = array('orderMethod', 'orderAll', 'orderWriter', 'orderPublisher', 'orderJournal',);
		foreach($array AS $key)
		{
			if(isset($this->vars[$key]) && $this->vars[$key])
			{
				if(!$this->session->setVar($key, $this->vars[$key]))
					$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
			}
		}
// multiple selections
		if(isset($this->vars['orderGroup']) && $this->vars['orderGroup'])
		{
			if(!$this->session->setVar('orderGroup', trim(implode(',', $this->vars['orderGroup']))))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
		if(isset($this->vars['orderKeyword']) && $this->vars['orderKeyword'])
		{
			if(!$this->session->setVar('orderKeyword', trim(implode(',', $this->vars['orderKeyword']))))
				$this->auth->gracefulExit(TRUE, 'Unable to write to session.');
		}
	}
}
?>
