<?php
/*****
* Configuration class
*****/
class CONFIG
{
// Constructor
	function CONFIG()
	{
	}
// configure types of resources:
	function resourceTypes()
	{
		$this->types = array(
					'book'			=>	'Book',
					'book_article'		=>	'Book article',
					'journal_article'	=>	'Journal article',
					'web_article'		=>	'Web article',
				);
	}
// configure types of resources with journal title:
	function resourceTypesJournal()
	{
		$this->types = array(
					'journal_article'	=>	'Journal article',
					'web_article'		=>	'Web article',
				);
	}
// configure types of resources with publisher:
	function resourceTypesPublisher()
	{
		$this->types = array(
					'book'			=>	'Book',
					'book_article'		=>	'Book article',
				);
	}
// MySQL fields for a resource
	function getFields($resource)
	{
		$book = array(
				'author1_firstname'	=>	'Firstname',
				'author1_surname'	=>	'Surname',
				'author1_initials'	=>	'Initial(s)',
				'author2_firstname'	=>	'Firstname',
				'author2_surname'	=>	'Surname',
				'author2_initials'	=>	'Initial(s)',
				'author3_firstname'	=>	'Firstname',
				'author3_surname'	=>	'Surname',
				'author3_initials'	=>	'Initial(s)',
				'author4_firstname'	=>	'Firstname',
				'author4_surname'	=>	'Surname',
				'author4_initials'	=>	'Initial(s)',
				'author5_firstname'	=>	'Firstname',
				'author5_surname'	=>	'Surname',
				'author5_initials'	=>	'Initial(s)',
				'author6_firstname'	=>	'Firstname',
				'author6_surname'	=>	'Surname',
				'author6_initials'	=>	'Initial(s)',
				'et_al'			=>	'More authors (et al)',
				'editor1_firstname'	=>	'Firstname',
				'editor1_surname'	=>	'Surname',
				'editor1_initials'	=>	'Initial(s)',
				'editor2_firstname'	=>	'Firstname',
				'editor2_surname'	=>	'Surname',
				'editor2_initials'	=>	'Initial(s)',
				'editor3_firstname'	=>	'Firstname',
				'editor3_surname'	=>	'Surname',
				'editor3_initials'	=>	'Initial(s)',
				'editor4_firstname'	=>	'Firstname',
				'editor4_surname'	=>	'Surname',
				'editor4_initials'	=>	'Initial(s)',
				'editor5_firstname'	=>	'Firstname',
				'editor5_surname'	=>	'Surname',
				'editor5_initials'	=>	'Initial(s)',
				'editor6_firstname'	=>	'Firstname',
				'editor6_surname'	=>	'Surname',
				'editor6_initials'	=>	'Initial(s)',
				'ed_et_al'		=>	'More editors (et al)',
				'translator1_firstname'	=>	'Firstname',
				'translator1_surname'	=>	'Surname',
				'translator1_initials'	=>	'Initials',
				'translator2_firstname'	=>	'Firstname',
				'translator2_surname'	=>	'Surname',
				'translator2_initials'	=>	'Initials',
				'translator3_firstname'	=>	'Firstname',
				'translator3_surname'	=>	'Surname',
				'translator3_initials'	=>	'Initials',
				'trans_et_al'		=>	'More translators (et al)',
				'reviser1_firstname'	=>	'Firstname',
				'reviser1_surname'	=>	'Surname',
				'reviser1_initials'	=>	'Initials',
				'reviser2_firstname'	=>	'Firstname',
				'reviser2_surname'	=>	'Surname',
				'reviser2_initials'	=>	'Initials',
				'reviser3_firstname'	=>	'Firstname',
				'reviser3_surname'	=>	'Surname',
				'reviser3_initials'	=>	'Initials',
				'rev_et_al'		=>	'More revisers (et al)',
				'series_title'		=>	'Series title',
				'series_number'		=>	'Series number',
				'reprint_year'		=>	'Year of reprinting',
				'volumes'		=>	'Number of volumes',
				'volume_number'		=>	'Volume number',
				'volume_year'		=>	'Volume publication year',
				'publisher_name'	=>	'Name',
				'publisher_location'	=>	'Location',
				'year'			=>	'Year of publication',
				'edition'		=>	'Edition',
			);
		$book_article = array(
				'author1_firstname'	=>	'Firstname',
				'author1_surname'	=>	'Surname',
				'author1_initials'	=>	'Initial(s)',
				'author2_firstname'	=>	'Firstname',
				'author2_surname'	=>	'Surname',
				'author2_initials'	=>	'Initial(s)',
				'author3_firstname'	=>	'Firstname',
				'author3_surname'	=>	'Surname',
				'author3_initials'	=>	'Initial(s)',
				'author4_firstname'	=>	'Firstname',
				'author4_surname'	=>	'Surname',
				'author4_initials'	=>	'Initial(s)',
				'author5_firstname'	=>	'Firstname',
				'author5_surname'	=>	'Surname',
				'author5_initials'	=>	'Initial(s)',
				'author6_firstname'	=>	'Firstname',
				'author6_surname'	=>	'Surname',
				'author6_initials'	=>	'Initial(s)',
				'et_al'			=>	'More authors (et al)',
				'editor1_firstname'	=>	'Firstname',
				'editor1_surname'	=>	'Surname',
				'editor1_initials'	=>	'Initial(s)',
				'editor2_firstname'	=>	'Firstname',
				'editor2_surname'	=>	'Surname',
				'editor2_initials'	=>	'Initial(s)',
				'editor3_firstname'	=>	'Firstname',
				'editor3_surname'	=>	'Surname',
				'editor3_initials'	=>	'Initial(s)',
				'editor4_firstname'	=>	'Firstname',
				'editor4_surname'	=>	'Surname',
				'editor4_initials'	=>	'Initial(s)',
				'editor5_firstname'	=>	'Firstname',
				'editor5_surname'	=>	'Surname',
				'editor5_initials'	=>	'Initial(s)',
				'editor6_firstname'	=>	'Firstname',
				'editor6_surname'	=>	'Surname',
				'editor6_initials'	=>	'Initial(s)',
				'ed_et_al'		=>	'More editors (et al)',
				'book_title'		=>	'Book title',
				'translator1_firstname'	=>	'Firstname',
				'translator1_surname'	=>	'Surname',
				'translator1_initials'	=>	'Initials',
				'translator2_firstname'	=>	'Firstname',
				'translator2_surname'	=>	'Surname',
				'translator2_initials'	=>	'Initials',
				'translator3_firstname'	=>	'Firstname',
				'translator3_surname'	=>	'Surname',
				'translator3_initials'	=>	'Initials',
				'trans_et_al'		=>	'More translators (et al)',
				'reviser1_firstname'	=>	'Firstname',
				'reviser1_surname'	=>	'Surname',
				'reviser1_initials'	=>	'Initials',
				'reviser2_firstname'	=>	'Firstname',
				'reviser2_surname'	=>	'Surname',
				'reviser2_initials'	=>	'Initials',
				'reviser3_firstname'	=>	'Firstname',
				'reviser3_surname'	=>	'Surname',
				'reviser3_initials'	=>	'Initials',
				'rev_et_al'		=>	'More revisers (et al)',
				'series_title'		=>	'Series title',
				'series_number'		=>	'Series number',
				'reprint_year'		=>	'Year of reprinting',
				'volumes'		=>	'Number of volumes',
				'volume_number'		=>	'Volume number',
				'volume_year'		=>	'Volume publication year',
				'page_start'		=>	'Article start page',
				'page_end'		=>	'Article end page',
				'publisher_name'	=>	'Name',
				'publisher_location'	=>	'Location',
				'year'			=>	'Year of publication',
				'edition'		=>	'Edition',
			);
		$journal_article = array(
				'author1_firstname'	=>	'Firstname',
				'author1_surname'	=>	'Surname',
				'author1_initials'	=>	'Initial(s)',
				'author2_firstname'	=>	'Firstname',
				'author2_surname'	=>	'Surname',
				'author2_initials'	=>	'Initial(s)',
				'author3_firstname'	=>	'Firstname',
				'author3_surname'	=>	'Surname',
				'author3_initials'	=>	'Initial(s)',
				'author4_firstname'	=>	'Firstname',
				'author4_surname'	=>	'Surname',
				'author4_initials'	=>	'Initial(s)',
				'author5_firstname'	=>	'Firstname',
				'author5_surname'	=>	'Surname',
				'author5_initials'	=>	'Initial(s)',
				'author6_firstname'	=>	'Firstname',
				'author6_surname'	=>	'Surname',
				'author6_initials'	=>	'Initial(s)',
				'et_al'			=>	'More authors (et al)',
				'journal_title'		=>	'Journal title',
				'page_start'		=>	'Article start page',
				'page_end'		=>	'Article end page',
				'year'			=>	'Year of publication',
				'journal_volume'	=>	'Journal Volume',
				'journal_number'	=>	'Journal Number',
			);
		$web_article = array(
				'author1_firstname'	=>	'Firstname',
				'author1_surname'	=>	'Surname',
				'author1_initials'	=>	'Initial(s)',
				'author2_firstname'	=>	'Firstname',
				'author2_surname'	=>	'Surname',
				'author2_initials'	=>	'Initial(s)',
				'author3_firstname'	=>	'Firstname',
				'author3_surname'	=>	'Surname',
				'author3_initials'	=>	'Initial(s)',
				'author4_firstname'	=>	'Firstname',
				'author4_surname'	=>	'Surname',
				'author4_initials'	=>	'Initial(s)',
				'author5_firstname'	=>	'Firstname',
				'author5_surname'	=>	'Surname',
				'author5_initials'	=>	'Initial(s)',
				'author6_firstname'	=>	'Firstname',
				'author6_surname'	=>	'Surname',
				'author6_initials'	=>	'Initial(s)',
				'et_al'			=>	'More authors (et al)',
				'journal_title'		=>	'Journal title',
				'web_address'		=>	'Article address',
				'year'			=>	'Year of publication',
				'journal_volume'	=>	'Journal Volume',
				'journal_number'	=>	'Journal Number',
				'page_start'		=>	'Article start page',
				'page_end'		=>	'Article end page',
				'date_accessed'		=>	'Date accessed',
			);
		$this->fields = $$resource;
	}
// All possible columns in the xxxx_details tables
	function detailColumns($resource)
	{
				$book = array(
						'title'			=>	TRUE,
						'subtitle'		=>	TRUE,
						'type'			=>	TRUE,
						'author1'		=>	TRUE,
						'author2'		=>	TRUE,
						'author3'		=>	TRUE,
						'author4'		=>	TRUE,
						'author5'		=>	TRUE,
						'author6'		=>	TRUE,
						'et_al'			=>	TRUE,
						'editor1'		=>	TRUE,
						'editor2'		=>	TRUE,
						'editor3'		=>	TRUE,
						'editor4'		=>	TRUE,
						'editor5'		=>	TRUE,
						'editor6'		=>	TRUE,
						'ed_et_al'		=>	TRUE,
						'publisher'		=>	TRUE,
						'edition'		=>	TRUE,
						'year'			=>	TRUE,
						'translator1'		=>	TRUE,
						'translator2'		=>	TRUE,
						'translator3'		=>	TRUE,
						'trans_et_al'		=>	TRUE,
						'reviser1'		=>	TRUE,
						'reviser2'		=>	TRUE,
						'reviser3'		=>	TRUE,
						'rev_et_al'		=>	TRUE,
						'series_title'		=>	TRUE,
						'series_number'		=>	TRUE,
						'volumes'		=>	TRUE,
						'volume_number'		=>	TRUE,
						'volume_year'		=>	TRUE,
						'reprint_year'		=>	TRUE,
					);
				$book_article = array(
						'title'			=>	TRUE,
						'subtitle'		=>	TRUE,
						'type'			=>	TRUE,
						'author1'		=>	TRUE,
						'author2'		=>	TRUE,
						'author3'		=>	TRUE,
						'author4'		=>	TRUE,
						'author5'		=>	TRUE,
						'author6'		=>	TRUE,
						'et_al'			=>	TRUE,
						'editor1'		=>	TRUE,
						'editor2'		=>	TRUE,
						'editor3'		=>	TRUE,
						'editor4'		=>	TRUE,
						'editor5'		=>	TRUE,
						'editor6'		=>	TRUE,
						'ed_et_al'		=>	TRUE,
						'publisher'		=>	TRUE,
						'edition'		=>	TRUE,
						'year'			=>	TRUE,
						'book_title'		=>	TRUE,
						'translator1'		=>	TRUE,
						'translator2'		=>	TRUE,
						'translator3'		=>	TRUE,
						'trans_et_al'		=>	TRUE,
						'reviser1'		=>	TRUE,
						'reviser2'		=>	TRUE,
						'reviser3'		=>	TRUE,
						'rev_et_al'		=>	TRUE,
						'series_title'		=>	TRUE,
						'series_number'		=>	TRUE,
						'volumes'		=>	TRUE,
						'volume_number'		=>	TRUE,
						'volume_year'		=>	TRUE,
						'reprint_year'		=>	TRUE,
						'page_start'		=>	TRUE,
						'page_end'		=>	TRUE,
					);
				$journal_article = array(
						'title'			=>	TRUE,
						'subtitle'		=>	TRUE,
						'type'			=>	TRUE,
						'author1'		=>	TRUE,
						'author2'		=>	TRUE,
						'author3'		=>	TRUE,
						'author4'		=>	TRUE,
						'author5'		=>	TRUE,
						'author6'		=>	TRUE,
						'et_al'			=>	TRUE,
						'year'			=>	TRUE,
						'journal'		=>	TRUE,
						'page_start'		=>	TRUE,
						'page_end'		=>	TRUE,
						'journal_volume'	=>	TRUE,
						'journal_number'	=>	TRUE,
					);
				$web_article = array(
						'title'			=>	TRUE,
						'subtitle'		=>	TRUE,
						'type'			=>	TRUE,
						'author1'		=>	TRUE,
						'author2'		=>	TRUE,
						'author3'		=>	TRUE,
						'author4'		=>	TRUE,
						'author5'		=>	TRUE,
						'author6'		=>	TRUE,
						'et_al'			=>	TRUE,
						'year'			=>	TRUE,
						'journal'		=>	TRUE,
						'page_start'		=>	TRUE,
						'page_end'		=>	TRUE,
						'journal_volume'	=>	TRUE,
						'journal_number'	=>	TRUE,
						'web_address'		=>	TRUE,
						'date_accessed'		=>	TRUE,
					);
				$all = array(
						'title'			=>	TRUE,
						'type'			=>	TRUE,
						'subtitle'		=>	TRUE,
						'author1'		=>	TRUE,
						'author2'		=>	TRUE,
						'author3'		=>	TRUE,
						'author4'		=>	TRUE,
						'author5'		=>	TRUE,
						'author6'		=>	TRUE,
						'et_al'			=>	TRUE,
						'editor1'		=>	TRUE,
						'editor2'		=>	TRUE,
						'editor3'		=>	TRUE,
						'editor4'		=>	TRUE,
						'editor5'		=>	TRUE,
						'editor6'		=>	TRUE,
						'ed_et_al'		=>	TRUE,
						'publisher'		=>	TRUE,
						'edition'		=>	TRUE,
						'year'			=>	TRUE,
						'book_title'		=>	TRUE,
						'journal'		=>	TRUE,
						'translator1'		=>	TRUE,
						'translator2'		=>	TRUE,
						'translator3'		=>	TRUE,
						'trans_et_al'		=>	TRUE,
						'reviser1'		=>	TRUE,
						'reviser2'		=>	TRUE,
						'reviser3'		=>	TRUE,
						'rev_et_al'		=>	TRUE,
						'series_title'		=>	TRUE,
						'series_number'		=>	TRUE,
						'volumes'		=>	TRUE,
						'volume_number'		=>	TRUE,
						'volume_year'		=>	TRUE,
						'reprint_year'		=>	TRUE,
						'page_start'		=>	TRUE,
						'page_end'		=>	TRUE,
						'journal_volume'	=>	TRUE,
						'journal_number'	=>	TRUE,
						'web_address'		=>	TRUE,
						'date_accessed'		=>	TRUE,
					);
		$this->details = $$resource;
	}
// Create common SQL statement for operations such as search and formatting resource details.
// These usually require suffixes in the appropriate class.
// Designed to extract all possible details about a resource with the exception of notes, quotes and musings.
// $type is one of the arrays in $this->detailColumns() above.
	function commonSql($type)
	{
		$this->detailColumns($type);
		foreach(array_keys($this->details) as $name => $value)
			$resourceArray[] = "resource." . $value;
		$this->stmt = "resource.id AS resourceID, " . implode(', ', array_values($resourceArray)) . 
			", a1.surname AS author1_surname, 
			a1.firstname AS author1_firstname,
			a1.initials AS author1_initials, 
			a2.surname AS author2_surname, 
			a2.firstname AS author2_firstname,
			a2.initials AS author2_initials, 
			a3.surname AS author3_surname, 
			a3.firstname AS author3_firstname,
			a3.initials AS author3_initials, 
			a4.surname AS author4_surname, 
			a4.firstname AS author4_firstname,
			a4.initials AS author4_initials, 
			a5.surname AS author5_surname, 
			a5.firstname AS author5_firstname,
			a5.initials AS author5_initials, 
			a6.surname AS author6_surname, 
			a6.firstname AS author6_firstname,
			a6.initials AS author6_initials, 
			e1.surname AS editor1_surname, 
			e1.firstname AS editor1_firstname,
			e1.initials AS editor1_initials, 
			e2.surname AS editor2_surname, 
			e2.firstname AS editor2_firstname,
			e2.initials AS editor2_initials, 
			e3.surname AS editor3_surname, 
			e3.firstname AS editor3_firstname,
			e3.initials AS editor3_initials, 
			e4.surname AS editor4_surname, 
			e4.firstname AS editor4_firstname,
			e4.initials AS editor4_initials, 
			e5.surname AS editor5_surname, 
			e5.firstname AS editor5_firstname,
			e5.initials AS editor5_initials, 
			e6.surname AS editor6_surname, 
			e6.firstname AS editor6_firstname,
			e6.initials AS editor6_initials, 
			t1.surname AS translator1_surname, 
			t1.firstname AS translator1_firstname,
			t1.initials AS translator1_initials, 
			t2.surname AS translator2_surname, 
			t2.firstname AS translator2_firstname,
			t2.initials AS translator2_initials, 
			t3.surname AS translator3_surname, 
			t3.firstname AS translator3_firstname,
			t3.initials AS translator3_initials, 
			r1.surname AS reviser1_surname, 
			r1.firstname AS reviser1_firstname,
			r1.initials AS reviser1_initials, 
			r2.surname AS reviser2_surname, 
			r2.firstname AS reviser2_firstname,
			r2.initials AS reviser2_initials, 
			r3.surname AS reviser3_surname, 
			r3.firstname AS reviser3_firstname,
			r3.initials AS reviser3_initials, 
			publisher.name AS publisher_name, publisher.location AS publisher_location, 
			journal.journal_title";
		$this->condition = "LEFT JOIN writer AS a1 on 
			COALESCE(author1, editor1) = a1.id 
			LEFT JOIN writer AS a2 on 
			author2 = a2.id 
			LEFT JOIN writer AS a3 on 
			author3 = a3.id 
			LEFT JOIN writer AS a4 on 
			author4 = a4.id 
			LEFT JOIN writer AS a5 on 
			author5 = a5.id 
			LEFT JOIN writer AS a6 on 
			author6 = a6.id 
			LEFT JOIN writer AS e1 on 
			editor1 = e1.id 
			LEFT JOIN writer AS e2 on 
			editor2 = e2.id 
			LEFT JOIN writer AS e3 on 
			editor3 = e3.id 
			LEFT JOIN writer AS e4 on 
			editor4 = e4.id 
			LEFT JOIN writer AS e5 on 
			editor5 = e5.id 
			LEFT JOIN writer AS e6 on 
			editor6 = e6.id 
			LEFT JOIN writer AS t1 on 
			translator1 = t1.id 
			LEFT JOIN writer AS t2 on 
			translator2 = t2.id 
			LEFT JOIN writer AS t3 on 
			translator3 = t3.id 
			LEFT JOIN writer AS r1 on 
			reviser1 = r1.id 
			LEFT JOIN writer AS r2 on 
			reviser2 = r2.id 
			LEFT JOIN writer AS r3 on 
			reviser3 = r3.id 
			LEFT JOIN publisher ON 
			publisher=publisher.id 
			LEFT JOIN journal ON 
			journal=journal.id";
		$this->condition2 = "LEFT JOIN writer AS a1 on 
			author1 = a1.id 
			LEFT JOIN writer AS a2 on 
			author2 = a2.id 
			LEFT JOIN writer AS a3 on 
			author3 = a3.id 
			LEFT JOIN writer AS a4 on 
			author4 = a4.id 
			LEFT JOIN writer AS a5 on 
			author5 = a5.id 
			LEFT JOIN writer AS a6 on 
			author6 = a6.id 
			LEFT JOIN writer AS e1 on 
			editor1 = e1.id 
			LEFT JOIN writer AS e2 on 
			editor2 = e2.id 
			LEFT JOIN writer AS e3 on 
			editor3 = e3.id 
			LEFT JOIN writer AS e4 on 
			editor4 = e4.id 
			LEFT JOIN writer AS e5 on 
			editor5 = e5.id 
			LEFT JOIN writer AS e6 on 
			editor6 = e6.id 
			LEFT JOIN writer AS t1 on 
			translator1 = t1.id 
			LEFT JOIN writer AS t2 on 
			translator2 = t2.id 
			LEFT JOIN writer AS t3 on 
			translator3 = t3.id 
			LEFT JOIN writer AS r1 on 
			reviser1 = r1.id 
			LEFT JOIN writer AS r2 on 
			reviser2 = r2.id 
			LEFT JOIN writer AS r3 on 
			reviser3 = r3.id 
			LEFT JOIN publisher ON 
			publisher=publisher.id 
			LEFT JOIN journal ON 
			journal=journal.id ";
	}
//  All the possible different types of writers
	function writers()
	{
		$this->writersArray = array('author1', 'author2', 'author3', 'author4', 'author5', 'author6', 
			'editor1', 'editor2', 'editor3', 'editor4', 'editor5', 'editor6', 
			'translator1', 'translator2', 'translator3', 
			'reviser1', 'reviser2', 'reviser3',
				);
	}
// columns to order resources on from ORDER.php
	function order()
	{
		$this->orderArray = array(
				'author'	=>	'First Author',
				'type'		=>	'Resource Type',
				'title'		=>	'Title',
				'publisher'	=>	'Publisher',
				'year'		=>	'Year of Publication',
				'group'		=>	'Group',
				'keyword'	=>	'Keyword',
			);
	}
}
?>
