<?php
/*****
*	Editor class (also used for translators and revisers)
*****/
class EDITOR
{
// Constructor
	function EDITOR($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		$this->writers = array();
		$this->pString = '';
	}
// Display form fields for inputting editor names.
	function formFields($type, $editor = 'editor1')
	{
		$numEditors = $this->session->getVar('numEditors');
// if ! $numAuthors, we are editing and numEditors has not been written to session.  Display all editors fields.
		if(!$this->session->issetVar('numEditors'))
			$numEditors = 6;
		if(!$numEditors)
			return;
		include_once("classes/NAME.php");
		$name = new NAME($this->db, $type);
		if(sizeof($this->writers) || $this->writers = $name->grabAll())
		{
			$this->pString .= $name->preExistFormFields($editor, $this->writers);
		}
		else
		{
			if($editor == 'editor1')
			{
				$title = 'First Editor:';
				$class = "trFrame1";
			}
			else if($editor == 'editor2')
			{
				$title = 'Second Editor:';
				$class = "trFrame2";
			}
			else if($editor == 'editor3')
			{
				$title = 'Third Editor:';
				$class = "trFrame1";
			}
			else if($editor == 'editor4')
			{
				$title = 'Fourth Editor:';
				$class = "trFrame2";
			}
			else if($editor == 'editor5')
			{
				$title = 'Fifth Editor:';
				$class = "trFrame1";
			}
			else if($editor == 'editor6')
			{
				$title = 'Sixth Editor:';
				$class = "trFrame2";
			}
			$this->pString .= "<DIV CLASS=\"tr100\"><B>$title</B></DIV>";
			$this->pString .= "</DIV><DIV class=\"$class\">";
		}
		$this->pString .= $name->firstname($editor);
		$this->pString .= $name->initials($editor);
		$this->pString .= $name->surname($editor);
		if(($editor == 'editor1') && ($numEditors > 1))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->formFields($type, 'editor2');
		}
		else if(($editor == 'editor2') && ($numEditors > 2))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$this->formFields($type, 'editor3');
		}
		else if(($editor == 'editor3') && ($numEditors > 3))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->formFields($type, 'editor4');
		}
		else if(($editor == 'editor4') && ($numEditors > 4))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$this->formFields($type, 'editor5');
		}
		else if(($editor == 'editor5') && ($numEditors > 5))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->formFields($type, 'editor6');
		}
		else
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$this->pString .= $name->etAl('ed_et_al');
			$this->pString .= "</DIV><DIV CLASS=\"clear\"><HR></DIV>";
			$this->pString .= "<DIV class=\"trFrame1\">";
		}
		return $this->pString;
	}
// for type = 'book' and 'book_article', display translator fields
	function transFields($type, $trans, $firstTime = TRUE)
	{
		$numTranslators = $this->session->getVar('numTranslators');
// if ! $numAuthors, we are editing and numTranslators has not been written to session.  Display all authors fields.
		if(!$this->session->issetVar('numTranslators'))
			$numTranslators = 3;
		if(!$numTranslators)
			return;
		include_once("classes/NAME.php");
		$name = new NAME($this->db, $type);
		if($firstTime)
			$this->pString = '';
		if(sizeof($this->writers) || $this->writers = $name->grabAll())
		{
			$this->pString .= $name->preExistFormFields($trans, $this->writers);
		}
		else
		{
			if($trans == 'translator1')
			{
				$title = 'First Translator:';
				$class = "trFrame1";
			}
			else if($rev == 'translator2')
			{
				$title = 'Second translator:';
				$class = "trFrame2";
			}
			else if($rev == 'translator3')
			{
				$title = 'Third translator:';
				$class = "trFrame1";
			}
			$this->pString .= "<DIV CLASS=\"tr100\"><B>$title</B></DIV>";
			$this->pString .= "</DIV><DIV class=\"$class\">";
		}
		$this->pString .= $name->firstname($trans);
		$this->pString .= $name->initials($trans);
		$this->pString .= $name->surname($trans);
		if(($trans == 'translator1') && ($numTranslators > 1))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->transFields($type, 'translator2', FALSE);
		}
		else if(($trans == 'translator2') && ($numTranslators > 2))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$this->transFields($type, 'translator3', FALSE);
		}
		else
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->pString .= $name->etAl('trans_et_al');
			$this->pString .= "</DIV><DIV CLASS=\"clear\"><HR></DIV>";
			$this->pString .= "<DIV class=\"trFrame1\">";
		}
		return $this->pString;
	}
// for type = 'book' and 'book_article', display reviser fields
	function revFields($type, $rev, $firstTime = TRUE)
	{
		$numRevisers = $this->session->getVar('numRevisers');
// if ! $numAuthors, we are editing and numTranslators has not been written to session.  Display all authors fields.
		if(!$this->session->issetVar('numRevisers'))
			$numRevisers = 3;
		if(!$numRevisers)
			return;
		include_once("classes/NAME.php");
		$name = new NAME($this->db, $type);
		if($firstTime)
			$this->pString = '';
		if(sizeof($this->writers) || $this->writers = $name->grabAll())
		{
			$this->pString .= $name->preExistFormFields($rev, $this->writers);
		}
		else
		{
			if($rev == 'reviser1')
			{
				$title = 'First Reviser:';
				$class = "trFrame1";
			}
			else if($rev == 'reviser2')
			{
				$title = 'Second reviser:';
				$class = "trFrame2";
			}
			else if($rev == 'reviser3')
			{
				$title = 'Third reviser:';
				$class = "trFrame1";
			}
			$this->pString .= "<DIV CLASS=\"tr100\"><B>$title</B></DIV>";
			$this->pString .= "</DIV><DIV class=\"$class\">";
		}
		$this->pString .= $name->firstname($rev);
		$this->pString .= $name->initials($rev);
		$this->pString .= $name->surname($rev);
		if(($rev == 'reviser1') && ($numRevisers > 1))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->revFields($type, 'reviser2', FALSE);
		}
		else if(($rev == 'reviser2') && ($numRevisers > 1))
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$this->revFields($type, 'reviser3', FALSE);
		}
		else
		{
			$this->pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
			$this->pString .= $name->etAl('rev_et_al');
			$this->pString .= "</DIV><DIV CLASS=\"clear\"><HR></DIV>";
			$this->pString .= "<DIV class=\"trFrame1\">";
		}
		return $this->pString;
	}
}
?>
