<?php
/*****
*	Group class.
*	Groups are stored in the $WIKINDX_GROUPS array in config.inc
*****/
class GROUP
{
// Constructor
	function GROUP($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
		global $WIKINDX_GROUPS;
		$this->groups = $WIKINDX_GROUPS;
		natcasesort($this->groups);
	}
// Display form fields for selecting groups.
	function formFields()
	{
		if(sizeof($this->groups) == 1)
			return "<INPUT TYPE=\"hidden\" NAME=\"selectGroup[]\" VALUE=\"1\">";
		include_once("classes/HTML.php");
		$html = new HTML();
		global $PHP_SELF;
		$pString = "<DIV class=\"trFrame1\">";
		$pString .= "<DIV CLASS=\"tr100\">";
		$pString .= "<B>Groups:</B><BR>";
		$pString .= "The resource must belong to one or more groups. A group is a category used to 
			organise the resources and can only be initialised by 
			the administrator of the WIKINDX. To select more than one group, 
			hold down [SHIFT] or [CTRL] on your keyboard.</DIV></DIV>";
		$pString .= "<DIV class=\"trFrame1\">";
		$pString .= "<DIV CLASS=\"tr1\">";
		$pString .= $html->selectFBoxValueMultiple('selectGroup[]', $this->groups, $size = 5);
		$pString .= "</DIV></DIV>";
		return $pString;
	}
// Display form fields for editing group alignment (EDIT a Resource).
	function formFieldsEdit($id)
	{
		if(sizeof($this->groups) == 1)
			return "<INPUT TYPE=\"hidden\" NAME=\"selectGroup[]\" VALUE=\"1\">";
		include_once("classes/HTML.php");
		$html = new HTML();
		global $PHP_SELF;
		$sql = $this->db->select('resource_groups', 'groups', "WHERE id=$id");
		$sth = $this->db->query($sql);
		$groups = explode(',', $this->db->fetchOne($sth));
		$pString = "<DIV class=\"trFrame1\">";
		$pString .= "<DIV CLASS=\"tr100\">";
		$pString .= "<B>Groups:</B><BR>";
		$pString .= "The resource must belong to one or more groups. A group is a category used to 
			organise the resources and can only be initialised by 
			the administrator of the WIKINDX. To select more than one group, 
			hold down [SHIFT] or [CTRL] on your keyboard.</DIV></DIV>";
		$pString .= "<DIV class=\"trFrame1\">";
		$pString .= "<DIV CLASS=\"tr1\">";
		$pString .=  $html->selectedBoxValueMultiple('selectGroup[]', $this->groups, $groups, $size = 5);
		$pString .= "</DIV></DIV>";
		return $pString;
	}
// write tables.
// selectGroup contains comma-separated list of IDs relating to $WIKINDX_GROUPS.
	function writeSql($resourceID, $edit = FALSE)
	{
		$finalIDs = array();
// NB getVar() returns false if data is not set.
		if($select = $this->session->getVar('selectGroup'))
		{
// find and delete '0' key if exists
			foreach(explode(',', $select) as $key)
			{
				if(!$key)
					continue;
				array_push($finalIDs, $key);
			}
		}
// groups column may not be NULL
		if(!sizeof($finalIDs))
			return FALSE;
// nsert $finalIDs as comma-separated list into resource_groups table
		if($edit)
		{
			$string = "groups='" . implode(',', $finalIDs) . "'";
			$sql = $this->db->update('resource_groups', $string, "WHERE id=$resourceID");
		}
		else
		{
			$string = "'$resourceID','" . implode(',', $finalIDs) . "'";
			$sql = $this->db->insert('resource_groups', 'id, groups', "$string");
		}
		if(!$this->db->query($sql))
			return FALSE;
		return TRUE;
	}
}
?>
