<?php
/*****
*	Journal Article resource class
*****/
class JOURNAL
{
// Constructor
	function JOURNAL($db, $web = FALSE)
	{
		$this->db = $db;
		$this->web = $web;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
	}
// Display form fields for inputting journal fields.
	function formFields($config, $edit = FALSE)
	{
		$pString = '';
		include_once("classes/HTML.php");
		$html = new HTML();
		if($this->grabAll())
		{
			$pString .= $this->preExistFormFields();
		}
		$req = '';
		if(!$this->web)
			$req = '*';
		$key = 'journal_title';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) :
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr1\"><B>$config[$key]</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"30\" MAXLENGTH=\"255\">$req</DIV>";
		$key = 'page_start';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr2\"><B>$config[$key]</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"5\" MAXLENGTH=\"4\">$req</DIV>";
		$key = 'page_end';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr3\"><B>$config[$key]</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"5\" MAXLENGTH=\"4\"></DIV>";
		$pString .= "</DIV><DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame2\">";
		$key = 'year';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = '';
		$pString .= "<DIV CLASS=\"tr1\"><B>$config[$key]</B><BR>";
		$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
			"\" SIZE=\"5\" MAXLENGTH=\"4\"></BR>";
		$pString .= "<DIV class=\"hint\">(e.g. 1999)</DIV></DIV>";
		$key = 'journal_volume';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = 'None';
		$newArray[0] = 'None';
		for($i = 1; $i <= 100; $i++)
			$newArray[$i] = $i;
		$pString .= "<DIV CLASS=\"tr2\"><B>$config[$key]</B><BR>";
		$this->session->getVar($key) ? 
			$pString .= $html->selectedBoxValue($key, $newArray, $sessVar, 5) : 
			$pString .= $html->selectFBoxValue($key, $newArray, 5);
		$pString .= "</DIV>";
		$key = 'journal_number';
		$this->session->getVar($key) ?
			$sessVar = $this->session->getVar($key) : 
			$sessVar = 'None';
		$newArray[0] = 'None';
		for($i = 1; $i <= 100; $i++)
			$newArray[$i] = $i;
		$pString .= "<DIV CLASS=\"tr3\"><B>$config[$key]</B><BR>";
		$this->session->getVar($key) ? 
			$pString .= $html->selectedBoxValue($key, $newArray, $sessVar, 5) : 
			$pString .= $html->selectFBoxValue($key, $newArray, 5);
		$pString .= "</DIV></DIV>";
		if($this->web)
		{
			$pString .= "<DIV CLASS=\"clear\"></DIV><DIV class=\"trFrame1\">";
			$key = 'web_address';
			$this->session->getVar($key) ?
				$sessVar = $this->session->getVar($key) : 
				$sessVar = 'http://';
			$pString .= "<DIV CLASS=\"tr60\"><B>$config[$key]</B><BR>";
			$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
				"\" SIZE=\"70\" MAXLENGTH=\"255\">*";
			$pString .= "<DIV class=\"hint\">(http://...)</DIV></DIV>";
			$key = 'date_accessed';
			$this->session->getVar($key) ?
				$sessVar = $this->session->getVar($key) : 
				$sessVar = date('Y-m-d');
			$pString .= "<DIV CLASS=\"tr3\"><B>$config[$key]</B><BR>";
			$pString .= "<INPUT TYPE=\"text\" NAME=\"$key\" VALUE=\"" . stripslashes($sessVar) . 
				"\" SIZE=\"11\" MAXLENGTH=\"10\">*";
			$pString .= "<DIV CLASS=\"hint\">(yyyy-mm-dd)</DIV></DIV></DIV>";
		}
		$pString .= "<DIV CLASS=\"clear\"><HR></DIV>";
		$pString .= "<DIV class=\"trFrame1\">";
		return $pString;
	}
// Write data to SQL tables
	function writeSql()
	{
// NB getVar() returns false if data is not set.
		if($this->session->issetVar('journal_title'))
		{
			$journal = $this->session->getVar('journal_title');
			if($journalID = $this->checkExists($journal))
				return $journalID;
			$string = "'" . $this->db->tidyInput($journal) . "'";
			$sql = $this->db->insert('journal', 'journal_title', "$string");
			if(!$this->db->query($sql))
				return FALSE;
			return $this->db->lastAutoID();
		}
		else if($this->session->getVar('journalID'))
		{
			return $this->session->getVar('journalID');
		}
		else
		{
// set to NULL if no input.
			return 'NULL';
		}
	}
// When editing a resource, the journal's name may be edited.  If the original journal
//  no longer has attached resources, remove from journal table.
	function checkDelete($id)
	{
		$condition = "WHERE journal=" . $id;
		$sql = $this->db->select('resource', 'journal', $condition);
		$sth = $this->db->query($sql);
		if($this->db->numRows($sth))
			return;
// If we reach here, journal no longer exists so delete from journal table
		$sql = $this->db->delete('journal', "WHERE id=" . $id);
		$this->db->query($sql);
		$this->db->optimize('journal');
	}
// check if journal title already exists
	function checkExists($title)
	{
		$sql = $this->db->select('journal', '*');
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
		{
			if(strtolower($title) == strtolower($row['journal_title']))
				return $row['id'];
		}
		return FALSE;
	}
// Display explanation and existing journals in select box first.
	function preExistFormFields()
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		$id = 'journalID';
		$newArray = array();
		$newArray[0] = 'None';
		foreach($this->journals as $key => $value)
			$newArray[$key] = $value;
		$pString = "<DIV CLASS=\"tr60\">";
		$pString .= "<B>Journal Title: </B>";
		$pString .= "<DIV CLASS=\"hint\">You may select a pre-existing journal or enter a new one.  
			A new entry will supersede the selection of a pre-existing journal.</DIV>";
		$pString .= "</DIV><DIV CLASS=\"tr3\">";
		$this->session->issetVar($id) ? 
			$pString .= $html->selectedBoxValue($id, $newArray, $this->session->getVar($id), 5) : 
			$pString .= $html->selectFBoxValue($id, $newArray, 5);
		$pString .= "</DIV></DIV><DIV CLASS=\"clear\"></DIV><DIV CLASS=\"trFrame1\">";
		return $pString;
	}
// grab all journals' IDs and names
	function grabAll()
	{
		$sql = $this->db->select('journal', '*', "ORDER BY journal_title");
		$sth = $this->db->query($sql);
		while($row = $this->db->fetchAssoc($sth))
			$this->journals[$row['id']] = $row['journal_title'];
		if($this->db->numRows($sth))
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}
	}
}
?>
