<?php
/*****
*	Musings class
*****/
class MUSINGS
{
// Constructor
	function MUSINGS($db)
	{
		$this->db = $db;
		include_once("classes/SESSION.php");
		$this->session = new SESSION();
	}
// display hyperlink for musing
	function displayLink($id, $numMusings)
	{
		global $PHP_SELF;
		if($numMusings)
			return "<A HREF=\"" . $PHP_SELF . 
				"?action=viewMusings&id=$id\">&nbsp;M&nbsp;</A>";
		else if($this->session->getVar('write'))
			return "<A HREF=\"" . $PHP_SELF . "?action=viewMusings&id=$id\">&nbsp;m&nbsp;</A>";
	}
// display a resource musing
	function display($id)
	{
		global $PHP_SELF;
		$string = 'title, m.id AS museID, musing';
		$condition = "WHERE r.id=$id AND m.resource_id=$id ORDER BY m.resource_id";
		$sql = $this->db->select('resource AS r, musings AS m', $string, $condition);
		$sth = $this->db->query($sql);
		$pString = '';
		if(!$this->db->numRows($sth))
		{
			$pString .= "<DIV CLASS=\"intro\">No musings yet.</DIV>";
			$pString .= "<DIV CLASS=\"clear\"></DIV>";
// are we allowed to add?
			if($this->session->getVar('write'))
			{
				$pString .= "<P><HR><P>";
				$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editMusingDisplay\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"resource_id\" VALUE=\"$id\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"new\">";
				$pString .= "<INPUT TYPE=\"submit\" VALUE=\"muse\"></FORM>";
			}
			$pString .= $this->session->previousLink();
			return $pString;
		}
		$index = 0;
		while($row = $this->db->fetchAssoc($sth))
		{
// Add the title of the resource first time through
			if(!$index)
				$pString .= "<B>" . $row['title'] . "</B>";
			($index % 2) ? $class = "table2" : $class = "table1";
			$pString .= "<DIV CLASS=\"$class\">";
			$pString .= "<DIV CLASS=\"tableLeft\">";
			$pString .= $this->nlReduce($this->toHtml(stripslashes($row['musing'])));
			$pString .= "</DIV>";
// are we allowed to edit?
			$pString .= "<DIV CLASS=\"tableRight\">";
			if($this->session->getVar('write'))
			{
				$pString .= "<A HREF=\"" . $PHP_SELF . 
					"?action=editMusingDisplay&resource_id=$id&id=" . 
					$row['museID'] . "\">E</A>&nbsp;";
			}
			$pString .= "</DIV></DIV><DIV CLASS=\"clear\"></DIV>";
			++$index;
		}
// are we allowed to add?
		if($this->session->getVar('write'))
		{
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editMusingDisplay\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"resource_id\" VALUE=\"$id\">";
			$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"new\">";
			$pString .= "<INPUT TYPE=\"submit\" VALUE=\"muse\"></FORM>";
		}
		$pString .= $this->session->previousLink();
		return $pString;
	}
// replace newlines and carriage returns with appropriate HTML entities.
// newline characters - first multiples then singles.
	function toHtml($string)
	{
		include_once("classes/HTML.php");
		$html = new HTML();
		return $html->urlToHtml($html->nlToHtml($string));
	}
// reduce the number of newlines replacing multiples with 2 
	function nlReduce($string)
	{
		$string = preg_replace("/(\015?\012){2,}/", "\n\n", $string);
		return preg_replace("/\n/", "\n", $string);
	}
// add a musing
	function add($vars)
	{
		global $PHP_SELF;
		$sqlKey = "resource_id, musing";
		$sqlValue = $vars['resource_id'] . ", '" . $this->db->tidyInput($vars['musing']) . "'";
		$sql = $this->db->insert('musings', $sqlKey, $sqlValue);
		if(!$this->db->query($sql))
			return FALSE;
		$pString = "Musing added successfully.";
		$pString .= "<DIV class=\"back\">Back to: <A HREF=\"" . $PHP_SELF . 
			"?action=viewMusings&id=" . $vars['resource_id'] . "\">View Musings</A></DIV>";
		$pString .= $this->session->previousLink();
		$this->summary($vars['resource_id']);
// reset the session variables to forestall reloading + rewriting of this quote to database.
		$this->session->resetSession(array('finaliseMusing' => TRUE));
		return $pString;
	}
// edit a musing
	function edit($id, $vars)
	{
		global $PHP_SELF;
		if(!$this->session->getVar('write'))
			return FALSE;
		$musing = $this->db->tidyInput($vars['musing']);
		$string = "musing='$musing'";
		$sql = $this->db->update('musings', "$string", "WHERE id=$id");
		if(!$this->db->query($sql))
			return FALSE;
		$sql = $this->db->update('resource', "timestamp=NULL", "WHERE id = " . $vars['resource_id']);
		$this->db->query($sql);
		$pString = "Musing edited successfully.";
		$pString .= "<DIV class=\"back\">Back to: <A HREF=\"" . $PHP_SELF . 
			"?action=viewMusings&id=" . $vars['resource_id'] . "\">View Musings</A></DIV>";
//		$pString .= $this->session->previousLink();
// reset the session variables to forestall reloading + rewriting of this quote to database.
		$this->session->resetSession(array('finaliseMusing' => TRUE));
		return $pString;
	}
// Form for editing musing
	function editDisplay($resourceID, $id)
	{
		$pString = '';
		if($this->session->getVar('write'))
		{
			global $PHP_SELF;
			$sql = $this->db->select('resource', 'type, title', "WHERE id=$resourceID");
			$sth = $this->db->query($sql);
			if(!$this->db->numRows($sth))
				return FALSE;
			$row = $this->db->fetchAssoc($sth);
			if($id != 'new')
			{
				$pString .= "<DIV class=\"back\"><A HREF=\"" . $PHP_SELF . 
					"?action=editMusingDisplay&id=" . $id . 
					"&resource_id=$resourceID\">Reload original data</A></DIV>";
			}
			$pString .= "<DIV CLASS=\"intro\" STYLE=\"width : 75%\"><B>" . $row['title'] . ":</B></DIV>";
			$pString .= "<DIV CLASS=\"clear\"></DIV>";
			$pString .= "[*] = required.<P>";
			$pString .= "<FORM METHOD=\"POST\" ACTION=\"" . $PHP_SELF . "\">";
// reset the session variable finalise flag
			$this->session->resetSession(array('finaliseMusing' => FALSE));
// add a new musing?
			if($id == 'new')
			{
				($musing = trim($this->session->getVar('quote'))) ? FALSE : $musing = '';
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"addMusing\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"resource_id\" VALUE=\"$resourceID\">";
				$pString .= "*Musing:<BR>
					<TEXTAREA NAME=\"musing\" COLS=\"80\" ROWS=\"10\">$musing</TEXTAREA><P>";
				$pString .= "<INPUT TYPE=\"submit\" VALUE=\"muse\"></FORM>";
			}
// or editing existing musing?
			else
			{
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"editMusing\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"id\" VALUE=\"$id\">";
				$pString .= "<INPUT TYPE=\"hidden\" NAME=\"resource_id\" VALUE=\"$resourceID\">";
				$sql = $this->db->select('musings', 'musing', "WHERE id=$id");
				$sth = $this->db->query($sql);
				($musing = trim($this->session->getVar('musing'))) ? FALSE : 
					$musing = $this->nlReduce(stripslashes($this->db->fetchOne($sth)));
				$pString .= "*Musing:<BR>
					<TEXTAREA NAME=\"musing\" COLS=\"80\" 
					ROWS=\"10\">$musing</TEXTAREA><P>";
				$pString .= "<P><INPUT TYPE=\"submit\" VALUE=\"edit\"></FORM>";
			}
		}
		else
		{
			$pString .= "You do not have write permissions.";
		}
		$pString .= $this->session->previousLink();
		return $pString;
	}
// update total_musings in summary table and update num_musings and timestamp in resource table
	function summary($id)
	{
		$sql = $this->db->update('summary', "total_musings = total_musings + 1");
		$this->db->query($sql);
		$sql = $this->db->update('resource', "timestamp=NULL, num_musings = num_musings + 1", "WHERE id = $id");
		$this->db->query($sql);
	}
// delete musings
	function deleteMusings($id)
	{
		$sql = $this->db->delete('musings', "WHERE resource_id=" . $id);
		$this->db->query($sql);
		$this->db->optimize('musings');
		$sql = $this->db->update('summary', "total_musings = total_musings - 1");
		$this->db->query($sql);
	}
}
?>
