<?php
/*****
*
*	Session functions
*
*****/
class SESSION
{
// Constructor
	function SESSION()
	{
// Initialise one
		global $DOMAIN;
		if(!isset($DOMAIN))
		{
			$domain = "localhost";
		}
		else
		{
			$domain = $DOMAIN;
		}
		$timeout = 0;
		$sesspath = '.';
//		$this->sessId = session_id();
		session_set_cookie_params($timeout, $sesspath, $domain);
	}
// Set a session variable
	function setVar($key, $value)
	{
		global $HTTP_SESSION_VARS;
		if(!isset($key) || !isset($value)) return false;
		$HTTP_SESSION_VARS[$key] = $value;
		if(!isset($HTTP_SESSION_VARS[$key]))
		{
			return false;
		}
		return true;
	}
// Get a session variable
	function getVar($key)
	{
		global $HTTP_SESSION_VARS;
		if(isset($HTTP_SESSION_VARS[$key]))
		{
			return stripslashes($HTTP_SESSION_VARS[$key]);
		}
		return false;
	}
// Delete a session variable
	function delVar($key)
	{
		global $HTTP_SESSION_VARS;
		unset($HTTP_SESSION_VARS[$key]);
	}
// Is a session variable set?
	function issetVar($key)
	{
		global $HTTP_SESSION_VARS;
		if(isset($HTTP_SESSION_VARS[$key])) return true;
		return false;
	}
// Destroy the whole session
	function destroy()
	{
		global $HTTP_SESSION_VARS;
		$HTTP_SESSION_VARS = array();
//		foreach($HTTP_SESSION_VARS as $key)
//			unset($HTTP_SESSION_VARS[$key]);
//		session_destroy();
	}
// reset a session, perhaps rewriting some data
	function resetSession($array = '')
	{
		$write = $admin = $link = $linkName = FALSE;
		if($this->getVar('write'))
			$write = TRUE;
		if($this->getVar('admin'))
			$admin = TRUE;
//		if($this->getVar('previousLink'))
//		{
//			$link = $this->getVar('previousLink');
//			$linkName = $this->getVar('previousLinkName');
//		}
		$this->destroy();
		$this->setVar('write', $write);
		$this->setVar('admin', $admin);
		if($link)
		{
			$this->setVar('previousLink', $link);
			$this->setVar('previousLinkName', $linkName);
		}
		if(is_array($array))
		{
			foreach($array as $key => $value)
				$this->setVar($key, $value);
		}
	}
// If a previous link ('Back to: ') is stored in the session, display in the browser
	function previousLink()
	{
		if($link = $this->getVar('previousLink'))
		{
			global $PHP_SELF;
			$pString = "<DIV ALIGN=\"right\" class=\"back\">Back to: <A HREF=\"" . $PHP_SELF . "?$link\">" . 
				stripslashes($this->getVar('previousLinkName')) . "</A></DIV>";
			$pString .= "<DIV CLASS=\"clear\"></DIV>";
			return $pString;
		}
	}
}
?>
