<?php
/*****
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
* NB. BEFORE YOU MAKE CHANGES TO THIS FILE, BACK IT UP!
*
* If you make changes, backup the edited file as future upgrades of WIKINDX will write over both this file
* and wikindx.css - no questions asked!
*****/
/*****
*
*	Global configuration file.
*	Define global variables here.
*	All variables (except integers and booleans) should be bounded by double quotes and terminated with ';'.
*
*****/

/*****
*
*	PATH variables
*
*****/
// classes etc. required by the system.  You probably don't want to change this 
// but, if you do, make sure it has a trailing '/':
$WIKINDX_PATH_TO_CLASSES = "classes/";
// session variable.  The domain that the session transmits - e.g. www.yourdomain.com
// Default is 'localhost'.
$WIKINDX_DOMAIN = "localhost";

/*****
*
*	database variables
*
*****/
// host on which the relational db management system is running (usually localhost if
// the web files are on the same server as the RDBMS)
// however, if running MS SQL, $WIKINDX_DB_HOST must be the full servername.
// NB:
// The database and the user for accessing it must be created using your RDBMS client. Wikindx 
// will NOT do this for you.  If unsure how to do this, contact your server admin.
$WIKINDX_DB_HOST = "localhost";
/**********************
* Database access:
**********************/
// name of the database which these scripts interface with:
$WIKINDX_DB = "wikindx";
// username and password required to connect to and open the database:
$WIKINDX_DB_USER = "wikindx";
$WIKINDX_DB_PASSWORD = "wikindx";
// rdbms type - currently:
//	MySQL -> 'mysql'
//	Postgres -> 'postgres'
//	Microsoft SQL -> 'mssql'
// THIS VERSION ONLY SUPPORTS MySQL!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$WIKINDX_DB_TYPE = "mysql";

/*****
*
*	Browser display variables
*
*****/
// Title to display in the web browser control bar and on the left of the title bar:
$WIKINDX_TITLE = "WIKINDX";
// Short description of the wikindx that appears in the centre of the title bar:
$WIKINDX_DESCRIPTION = "Bibliographic Resource";
// Message to display on the front page of the site. It can contain any HTML code that is valid between 
// <BODY></BODY> tags including reference to the stylesheet defined below.
// NB, if you need to use doublequotes in the message, remember to precede them with a 
// backslash '\' - e.g. \"mailto:blah@blah.com\":
$WIKINDX_FRONTPAGE = 
"
Welcome to the --::YOUR PROJECT NAME::-- WIKINDX!<P>
This wikindx is designed for research into absolutely anything at all. Enjoy and 
contribute wisely please!
";
// Contact details - displayed at the bottom of the home page.  It can contain any HTML code that is valid between 
// <BODY></BODY> tags including reference to the stylesheet defined below.  (Can be something other than contact if you
// wish since it simply acts as a footer on the front page.)
$WIKINDX_CONTACT = "Comments to <A HREF=\"mailto:blah@blah.com\">--::Your Name::--</A>";
// External style sheet - default is wikindx.css.
// It must reside in the same directory as this file.
// A quick fix to disable stylesheets, is to rename $WIKINDX_CSS_STLE to some non-existent file.
$WIKINDX_CSS_STYLE = "wikindx.css";
// Small image to display at top right of title bar.
// Default is wikindx.gif
$WIKINDX_IMAGE = "images/wikindx.gif";
// WIKINDX_IMAGE dimensions in pixels
$WIKINDX_IMAGE_HEIGHT = 31;
$WIKINDX_IMAGE_WIDTH = 100;

/*****
*
*	General authentication variables
*
*****/
// Is authentication required to write/edit the database?
// Valid values are TRUE and FALSE - do not bound with double quotes!
$WIKINDX_AUTH_WRITE = FALSE;

// Authentication username/password for WRITE operations.
// (Settings below will be functionless if $WIKINDX_AUTH_WRITE above is FALSE.)
// If you want better security access to the WIKINDX, then, as WIKINDX simply runs through a web server, 
// you would be better advised to configure your web server authentication protocols.
$WIKINDX_AUTH_WRITE_USERNAME = "wikindx";
$WIKINDX_AUTH_WRITE_PASSWORD = "wikindx";

/*****
*
*	Administration Options
*
*****/
// Are Administrative options only available to a select few?
// Valid values are TRUE and FALSE - do not bound with double quotes!
// Set this to FALSE for single use or if you trust your users.
// Setting to true will require administrators to authenticate with username and password below.
$WIKINDX_ADMIN_PRIVATE = TRUE;

// Authentication username/password for WRITE operations.
// (Settings below will be functionless if $WIKINDX_ADMIN_PRIVATE above is FALSE.)
// If you set $WIKINDX_AUTH_WRITE = TRUE above, it's probably not a good idea to use the same 
// username and password.
$WIKINDX_ADMIN_USERNAME = "admin";
$WIKINDX_ADMIN_PASSWORD = "admin";

/*****
*
*	Miscellaneous variables
*
*****/
// Groups are the major categories within the wikindx:  you must have at least one and each resource belongs to at 
// least one group.  Groups allow you to divide the wikindx database into logical sections which can be 
// searched separately or all at once.  Groups should be set up once BEFORE entering resources - editing this after 
// entering resources can have potentially disastrous consequences!  It is safe to add (especially if 
// you add at the end of the list), less safe to edit or remove and you definitely should NOT change 
// the numbering!  YOU HAVE BEEN WARNED!
// If you have only one group, all new resources are automatically a member of this group and users have no 'groups' 
// option when editing or adding resources.
// Given below is an example.  It is important that you follow the format exactly.  
// Further categories can be added by following the structure although it is advisable not to have too many since 
// 'keywords' (that users can enter) are used to further define the resources both within and across groups.
/*
Example groups array - this might be for a WIKINDX that covers the broad area of media:
$WIKINDX_GROUPS = array(
		'1'	=>	'Media Practice',
		'2'	=>	'Politics',
		'3'	=>	'Sociology',
	);
*/
$WIKINDX_GROUPS = array(
		'1'	=>	'History',
		'2'	=>	'Geography',
		'3'	=>	'Politics',
		'4'	=>	'Sociology',
		'5'	=>	'Music',
		'6'	=>	'Visual Arts',
		'7'	=>	'Technology',
		'8'	=>	'Science',
		'9'	=>	'Games',
		'10'	=>	'General',
	);
?>
